#

API Docs for: 0.3.35
Show: Inherited Protected Private Deprecated

# DocParser Class

Extends Base
Defined in: `lib/docparser.js:722`
Module: yuidoc

The doc parser accepts a map of files to file content. Once `parse()` is called, various properties will be populated with the parsers data (aggregated in the `'data'` property).

## Constructor

### `DocParser`

(

- `o`

)

Defined in `lib/docparser.js:722`

#### Parameters:

- `o` Object

  the config object

- Index
- Methods
- Properties
- Attributes
- Events

## Item Index

### Methods

- _addAttrs
- _addLazyAttr
- _aggregateAttrs
- _attrCfgHash
- _baseDestroy
- _baseInit
- _defAttrChangeFn
- _defDestroyFn
- _defInitFn
- _destroyHierarchy
- _filterAdHocAttrs
- _filterAttrCfs
- _fireAttrChange
- _getAttr
- _getAttrCfg
- _getAttrCfgs
- _getAttrInitVal
- _getAttrs
- _getClasses
- _getStateVal
- _getType
- _initAttrHost
- _initAttribute
- _initAttrs
- _initBase
- _initHierarchy
- _initHierarchyData
- _isLazyAttr
- _monitor
- _normAttrVals
- _parseType
- _preInitEventCfg
- _protectAttrs
- _resolveFor
- _set
- _setAttr
- _setAttrs
- _setAttrVal
- _setStateVal
- addAttr
- addAttrs
- addTarget
- after
- attrAdded
- before
- bubble
- destroy
- detach
- detachAll
- extract
- fire
- get
- getAttrs
- getEvent
- getTargets
- handlecomment
- init
- modifyAttr
- on
- once
- onceAfter
- parse
- parseType
- processblock
- publish
- removeAttr
- removeTarget
- reset
- set
- setAttrs
- stringlog
- subscribe deprecated
- toString
- transform
- unindent
- unsubscribe deprecated
- unsubscribeAll deprecated

### Properties

- _allowAdHocAttrs
- CORRECTIONS
- DIGESTERS
- name deprecated
- TAGLIST

### Attributes

- currentclass
- currentfile
- currentmodule
- currentsubmodule
- destroyed
- digesters
- dirmap
- emitters
- filemap
- initialized
- mainmodule
- syntaxtype

### Events

- destroy
- init

## Methods

### `_addAttrs`

(

- `cfgs`
- `values`
- `lazy`

)
private

Inherited from AttributeCore: `attribute/js/AttributeCore.js:741`

Implementation behind the public addAttrs method.

This method is invoked directly by get if it encounters a scenario in which an attribute's valueFn attempts to obtain the value an attribute in the same group of attributes, which has not yet been added (on demand initialization).

#### Parameters:

- `cfgs` Object

  An object with attribute name/configuration pairs.

- `values` Object

  An object with attribute name/value pairs, defining the initial values to apply. Values defined in the cfgs argument will be over-written by values in this argument unless defined as read only.

- `lazy` Boolean

  Whether or not to delay the intialization of these attributes until the first call to get/set. Individual attributes can over-ride this behavior by defining a lazyAdd configuration property in their configuration. See addAttr.

### `_addLazyAttr`

(

- `name`

)
private

Inherited from AttributeCore: `attribute/js/AttributeCore.js:312`

Finishes initializing an attribute which has been lazily added.

#### Parameters:

- `name` Object

  The name of the attribute

### `_aggregateAttrs`

(

- `allAttrs`

)
Object private

Inherited from BaseCore: `base/js/BaseCore.js:427`

A helper method, used by _initHierarchyData to aggregate attribute configuration across the instances class hierarchy.

The method will protect the attribute configuration value to protect the statically defined default value in ATTRS if required (if the value is an object literal, array or the attribute configuration has cloneDefaultValue set to shallow or deep).

#### Parameters:

- `allAttrs` Array

  An array of ATTRS definitions across classes in the hierarchy (subclass first, Base last)

#### Returns:

Object: The aggregate set of ATTRS definitions for the instance

### `_attrCfgHash`

() private

Inherited from BaseCore but overwritten in `base/js/Base.js:180`

Utility method to define the attribute hash used to filter/whitelist property mixes for this class.

### `_baseDestroy`

() private

Inherited from BaseCore: `base/js/BaseCore.js:264`

Internal destroy implementation for BaseCore

### `_baseInit`

() private

Inherited from BaseCore: `base/js/BaseCore.js:236`

Internal initialization implementation for BaseCore

### `_defAttrChangeFn`

(

- `e`

)
private

Inherited from AttributeEvents: `attribute/js/AttributeEvents.js:169`

Default function for attribute change events.

#### Parameters:

- `e` EventFacade

  The event object for attribute change events.

### `_defDestroyFn`

(

- `e`

)
protected

Inherited from Base: `base/js/Base.js:325`

Default destroy event handler

#### Parameters:

- `e` EventFacade

  Event object

### `_defInitFn`

(

- `e`

)
protected

Inherited from Base: `base/js/Base.js:313`

Default init event handler

#### Parameters:

- `e` EventFacade

  Event object, with a cfg property which refers to the configuration object passed to the constructor.

### `_destroyHierarchy`

() private

Inherited from BaseCore: `base/js/BaseCore.js:563`

Destroys the class hierarchy for this instance by invoking the destructor method on the prototype of each class in the hierarchy.

### `_filterAdHocAttrs`

(

- `allAttrs`
- `userVals`

)
Object private

Inherited from BaseCore: `base/js/BaseCore.js:343`

#### Parameters:

- `allAttrs` Object

  The set of all attribute configurations for this instance. Attributes will be removed from this set, if they belong to the filtered class, so that by the time all classes are processed, allCfgs will be empty.

- `userVals` Object

  The config object passed in by the user, from which adhoc attrs are to be filtered.

#### Returns:

Object: The set of adhoc attributes passed in, in the form of an object with attribute name/configuration pairs.

### `_filterAttrCfs`

(

- `clazz`
- `allCfgs`

)
Object private

Inherited from BaseCore: `base/js/BaseCore.js:311`

A helper method used when processing ATTRS across the class hierarchy during initialization. Returns a disposable object with the attributes defined for the provided class, extracted from the set of all attributes passed in.

#### Parameters:

- `clazz` Function

  The class for which the desired attributes are required.

- `allCfgs` Object

  The set of all attribute configurations for this instance. Attributes will be removed from this set, if they belong to the filtered class, so that by the time all classes are processed, allCfgs will be empty.

#### Returns:

Object: The set of attributes belonging to the class passed in, in the form of an object with attribute name/configuration pairs.

### `_fireAttrChange`

(

- `attrName`
- `subAttrName`
- `currVal`
- `newVal`
- `opts`

)
private

Inherited from AttributeEvents: `attribute/js/AttributeEvents.js:115`

Utility method to help setup the event payload and fire the attribute change event.

#### Parameters:

- `attrName` String

  The name of the attribute

- `subAttrName` String

  The full path of the property being changed, if this is a sub-attribute value being change. Otherwise null.

- `currVal` Any

  The current value of the attribute

- `newVal` Any

  The new value of the attribute

- `opts` Object

  Any additional event data to mix into the attribute change event's event facade.

### `_getAttr`

(

- `name`

)
Any protected chainable

Inherited from AttributeCore: `attribute/js/AttributeCore.js:468`

Provides the common implementation for the public get method, allowing Attribute hosts to over-ride either method.

See get for argument details.

#### Parameters:

- `name` String

  The name of the attribute.

#### Returns:

Any: The value of the attribute.

### `_getAttrCfg`

(

- `name`

)
Object protected

Inherited from AttributeExtras: `attribute/js/AttributeExtras.js:112`

Returns an object with the configuration properties (and value) for the given attribute. If attrName is not provided, returns the configuration properties for all attributes.

#### Parameters:

- `name` String

  Optional. The attribute name. If not provided, the method will return the configuration for all attributes.

#### Returns:

Object: The configuration properties for the given attribute, or all attributes.

### `_getAttrCfgs`

() Object protected

Inherited from BaseCore: `base/js/BaseCore.js:294`

Returns an aggregated set of attribute configurations, by traversing the class hierarchy.

#### Returns:

Object: The hash of attribute configurations, aggregated across classes in the hierarchy This value is cached the first time the method, or _getClasses, is invoked. Subsequent invocations return the cached value.

### `_getAttrInitVal`

(

- `attr`
- `cfg`
- `initValues`

)
Any private

Inherited from Attribute but overwritten in `attribute/js/AttributeCore.js:824`

Returns the initial value of the given attribute from either the default configuration provided, or the over-ridden value if it exists in the set of initValues provided and the attribute is not read-only.

#### Parameters:

- `attr` String

  The name of the attribute

- `cfg` Object

  The attribute configuration object

- `initValues` Object

  The object with simple and complex attribute name/value pairs returned from _normAttrVals

#### Returns:

Any: The initial value of the attribute.

### `_getAttrs`

(

- `attrs`

)
Object protected

Inherited from AttributeCore: `attribute/js/AttributeCore.js:678`

Implementation behind the public getAttrs method, to get multiple attribute values.

#### Parameters:

- `attrs` Array | boolean

  Optional. An array of attribute names. If omitted, all attribute values are returned. If set to true, all attributes modified from their initial values are returned.

#### Returns:

Object: An object with attribute name/value pairs.

### `_getClasses`

() Function[] protected

Inherited from BaseCore: `base/js/BaseCore.js:278`

Returns the class hierarchy for this object, with BaseCore being the last class in the array.

#### Returns:

Function[]: An array of classes (constructor functions), making up the class hierarchy for this object. This value is cached the first time the method, or _getAttrCfgs, is invoked. Subsequent invocations return the cached value.

### `_getStateVal`

(

- `name`

)
Any private

Inherited from AttributeCore: `attribute/js/AttributeCore.js:522`

Gets the stored value for the attribute, from either the internal state object, or the state proxy if it exits

#### Parameters:

- `name` String

  The name of the attribute

#### Returns:

Any: The stored value of the attribute

### `_getType`

() private

Inherited from EventTarget: `event-custom/js/event-target.js:36`

If the instance has a prefix attribute and the event type is not prefixed, the instance prefix is applied to the supplied type.

### `_initAttrHost`

(

- `attrs`
- `values`
- `lazy`

)
private

Inherited from AttributeCore: `attribute/js/AttributeCore.js:109`

Constructor logic for attributes. Initializes the host state, and sets up the inital attributes passed to the constructor.

#### Parameters:

- `attrs` Object

  The attributes to add during construction (passed through to addAttrs). These can also be defined on the constructor being augmented with Attribute by defining the ATTRS property on the constructor.

- `values` Object

  The initial attribute values to apply (passed through to addAttrs). These are not merged/cloned. The caller is responsible for isolating user provided values if required.

- `lazy` Boolean

  Whether or not to add attributes lazily (passed through to addAttrs).

### `_initAttribute`

() private

Inherited from BaseCore but overwritten in `base/js/Base.js:169`

Initializes Attribute

### `_initAttrs`

(

- `attrs`
- `values`
- `lazy`

)
protected

Inherited from AttributeCore: `attribute/js/AttributeCore.js:863`

Utility method to set up initial attributes defined during construction, either through the constructor.ATTRS property, or explicitly passed in.

#### Parameters:

- `attrs` Object

  The attributes to add during construction (passed through to addAttrs). These can also be defined on the constructor being augmented with Attribute by defining the ATTRS property on the constructor.

- `values` Object

  The initial attribute values to apply (passed through to addAttrs). These are not merged/cloned. The caller is responsible for isolating user provided values if required.

- `lazy` Boolean

  Whether or not to add attributes lazily (passed through to addAttrs).

### `_initBase`

(

- `config`

)
private

Inherited from BaseCore but overwritten in `base/js/Base.js:154`

Internal construction logic for Base.

#### Parameters:

- `config` Object

  The constructor configuration object

### `_initHierarchy`

(

- `userVals`

)
private

Inherited from BaseCore: `base/js/BaseCore.js:505`

Initializes the class hierarchy for the instance, which includes initializing attributes for each class defined in the class's static ATTRS property and invoking the initializer method on the prototype of each class in the hierarchy.

#### Parameters:

- `userVals` Object

  Object with configuration property name/value pairs

### `_initHierarchyData`

() private

Inherited from BaseCore: `base/js/BaseCore.js:373`

A helper method used by _getClasses and _getAttrCfgs, which determines both the array of classes and aggregate set of attribute configurations across the class hierarchy for the instance.

### `_isLazyAttr`

(

- `name`

)
Boolean private

Inherited from AttributeCore: `attribute/js/AttributeCore.js:299`

Checks whether or not the attribute is one which has been added lazily and still requires initialization.

#### Parameters:

- `name` String

  The name of the attribute

#### Returns:

Boolean: true if it's a lazily added attribute, false otherwise.

### `_monitor`

(

- `what`
- `eventType`
- `o`

)
private

Inherited from EventTarget: `event-custom/js/event-target.js:604`

This is the entry point for the event monitoring system. You can monitor 'attach', 'detach', 'fire', and 'publish'. When configured, these events generate an event. click -> clickattach, clickdetach, click_publish -- these can be subscribed to like other events to monitor the event system. Inividual published events can have monitoring turned on or off (publish can't be turned off before it it published) by setting the events 'monitor' config.

#### Parameters:

- `what` String

  'attach', 'detach', 'fire', or 'publish'

- `eventType` String | CustomEvent

  The prefixed name of the event being monitored, or the CustomEvent object.

- `o` Object

  Information about the event interaction, such as fire() args, subscription category, publish config

### `_normAttrVals`

(

- `valueHash`

)
Object private

Inherited from Attribute but overwritten in `attribute/js/AttributeCore.js:809`

Utility method to normalize attribute values. The base implementation simply merges the hash to protect the original.

#### Parameters:

- `valueHash` Object

  An object with attribute name/value pairs

#### Returns:

Object:

### `_parseType`

() private

Inherited from EventTarget: `event-custom/js/event-target.js:52`

Returns an array with the detach key (if provided), and the prefixed event name from _getType Y.on('detachcategory| menu:click', fn)

### `_preInitEventCfg`

(

- `config`

)
private

Inherited from Base: `base/js/Base.js:233`

Handles the special on, after and target properties which allow the user to easily configure on and after listeners as well as bubble targets during construction, prior to init.

#### Parameters:

- `config` Object

  The user configuration object

### `_protectAttrs`

(

- `attrs`

)
Object protected

Inherited from AttributeCore: `attribute/js/AttributeCore.js:787`

Utility method to protect an attribute configuration hash, by merging the entire object and the individual attr config objects.

#### Parameters:

- `attrs` Object

  A hash of attribute to configuration object pairs.

#### Returns:

Object: A protected version of the attrs argument.

### `_resolveFor`

(

- `value`

)
String private

Defined in `lib/docparser.js:991`

Takes a non-namespaced classname and resolves it to a namespace (to support `@for`)

#### Parameters:

- `value` String

  The classname to resolve

#### Returns:

String: The resolved namespace + classname

### `_set`

(

- `name`
- `val`

)
Object protected chainable

Inherited from AttributeEvents but overwritten in `attribute/js/AttributeCore.js:346`

Allows setting of readOnly/writeOnce attributes. See set for argument details.

#### Parameters:

- `name` String

  The name of the attribute.

- `val` Any

  The value to set the attribute to.

#### Returns:

Object: A reference to the host object.

### `_setAttr`

(

- `name`
- `value`
- `opts`
- `force`

)
Object protected chainable

Inherited from AttributeCore: `attribute/js/AttributeCore.js:361`

Provides the common implementation for the public set and protected _set methods.

See set for argument details.

#### Parameters:

- `name` String

  The name of the attribute.

- `value` Any

  The value to set the attribute to.

- `opts` Object

  (Optional) Optional event data to be mixed into the event facade passed to subscribers of the attribute's change event. This is currently a hack. There's no real need for the AttributeCore implementation to support this parameter, but breaking it out into AttributeEvents, results in additional function hops for the critical path.

- `force` Boolean

  If true, allows the caller to set values for readOnly or writeOnce attributes which have already been set.

#### Returns:

Object: A reference to the host object.

### `_setAttrs`

(

- `attrs`

)
Object protected chainable

Inherited from AttributeEvents but overwritten in `attribute/js/AttributeCore.js:647`

Implementation behind the public setAttrs method, to set multiple attribute values.

#### Parameters:

- `attrs` Object

  An object with attributes name/value pairs.

#### Returns:

Object: A reference to the host object.

### `_setAttrVal`

(

- `attrName`
- `subAttrName`
- `prevVal`
- `newVal`

)
Booolean private

Inherited from AttributeCore: `attribute/js/AttributeCore.js:554`

Updates the stored value of the attribute in the privately held State object, if validation and setter passes.

#### Parameters:

- `attrName` String

  The attribute name.

- `subAttrName` String

  The sub-attribute name, if setting a sub-attribute property ("x.y.z").

- `prevVal` Any

  The currently stored value of the attribute.

- `newVal` Any

  The value which is going to be stored.

#### Returns:

Booolean: true if the new attribute value was stored, false if not.

### `_setStateVal`

(

- `name`
- `value`

)
private

Inherited from AttributeCore: `attribute/js/AttributeCore.js:536`

Sets the stored value for the attribute, in either the internal state object, or the state proxy if it exits

#### Parameters:

- `name` String

  The name of the attribute

- `value` Any

  The value of the attribute

### `addAttr`

(

- `name`
- `config`
- `lazy`

)
Object chainable

Inherited from AttributeCore: `attribute/js/AttributeCore.js:124`

Adds an attribute with the provided configuration to the host object.

The config argument object supports the following properties:

value <Any>
  The initial value to set on the attribute
valueFn <Function | String>

  A function, which will return the initial value to set on the attribute. This is useful for cases where the attribute configuration is defined statically, but needs to reference the host instance ("this") to obtain an initial value. If both the value and valueFn properties are defined, the value returned by the valueFn has precedence over the value property, unless it returns undefined, in which case the value property is used.

  valueFn can also be set to a string, representing the name of the instance method to be used to retrieve the value.

readOnly <boolean>
  Whether or not the attribute is read only. Attributes having readOnly set to true cannot be modified by invoking the set method.
writeOnce <boolean> or <string>
  Whether or not the attribute is "write once". Attributes having writeOnce set to true, can only have their values set once, be it through the default configuration, constructor configuration arguments, or by invoking set.

  The writeOnce attribute can also be set to the string "initOnly", in which case the attribute can only be set during initialization (when used with Base, this means it can only be set during construction)

setter <Function | String>

  The setter function used to massage or normalize the value passed to the set method for the attribute. The value returned by the setter will be the final stored value. Returning Attribute.INVALID_VALUE, from the setter will prevent the value from being stored.

  setter can also be set to a string, representing the name of the instance method to be used as the setter function.

getter <Function | String>

  The getter function used to massage or normalize the value returned by the get method for the attribute. The value returned by the getter function is the value which will be returned to the user when they invoke get.

  getter can also be set to a string, representing the name of the instance method to be used as the getter function.

validator <Function | String>

  The validator function invoked prior to setting the stored value. Returning false from the validator function will prevent the value from being stored.

  validator can also be set to a string, representing the name of the instance method to be used as the validator function.

lazyAdd <boolean>
  Whether or not to delay initialization of the attribute until the first call to get/set it. This flag can be used to over-ride lazy initialization on a per attribute basis, when adding multiple attributes through the addAttrs method.

The setter, getter and validator are invoked with the value and name passed in as the first and second arguments, and with the context ("this") set to the host object.

Configuration properties outside of the list mentioned above are considered private properties used internally by attribute, and are not intended for public use.

#### Parameters:

- `name` String

  The name of the attribute.

- `config` Object

  An object with attribute configuration property/value pairs, specifying the configuration for the attribute.

  NOTE: The configuration object is modified when adding an attribute, so if you need to protect the original values, you will need to merge the object.

- `lazy` Boolean

  (optional) Whether or not to add this attribute lazily (on the first call to get/set).

#### Returns:

Object: A reference to the host object.

### `addAttrs`

(

- `cfgs`
- `values`
- `lazy`

)
Object chainable

Inherited from AttributeCore: `attribute/js/AttributeCore.js:709`

Configures a group of attributes, and sets initial values.

NOTE: This method does not isolate the configuration object by merging/cloning. The caller is responsible for merging/cloning the configuration object if required.

#### Parameters:

- `cfgs` Object

  An object with attribute name/configuration pairs.

- `values` Object

  An object with attribute name/value pairs, defining the initial values to apply. Values defined in the cfgs argument will be over-written by values in this argument unless defined as read only.

- `lazy` Boolean

  Whether or not to delay the intialization of these attributes until the first call to get/set. Individual attributes can over-ride this behavior by defining a lazyAdd configuration property in their configuration. See addAttr.

#### Returns:

Object: A reference to the host object.

### `addTarget`

(

- `o`

)

Inherited from EventTarget: `event-custom/js/event-facade.js:387`

Registers another EventTarget as a bubble target. Bubble order is determined by the order registered. Multiple targets can be specified.

Events can only bubble if emitFacade is true.

Included in the event-custom-complex submodule.

#### Parameters:

- `o` EventTarget

  the target to add

### `after`

(

- `type`
- `fn`
- `[context]`
- `[arg*]`

)
EventHandle

Inherited from EventTarget: `event-custom/js/event-target.js:744`

Subscribe to a custom event hosted by this object. The supplied callback will execute after any listeners add via the subscribe method, and after the default function, if configured for the event, has executed.

#### Parameters:

- `type` String

  The name of the event

- `fn` Function

  The callback to execute in response to the event

- `[context]` Object optional

  Override `this` object in callback

- `[arg*]` Any optional

  0..n additional arguments to supply to the subscriber

#### Returns:

EventHandle: A subscription handle capable of detaching the subscription

### `attrAdded`

(

- `name`

)
Boolean

Inherited from AttributeCore: `attribute/js/AttributeCore.js:272`

Checks if the given attribute has been added to the host

#### Parameters:

- `name` String

  The name of the attribute to check.

#### Returns:

Boolean: true if an attribute with the given name has been added, false if it hasn't. This method will return true for lazily added attributes.

### `before`

()

Inherited from EventTarget: `event-custom/js/event-target.js:781`

Executes the callback before a DOM event, custom event or method. If the first argument is a function, it is assumed the target is a method. For DOM and custom events, this is an alias for Y.on.

For DOM and custom events: type, callback, context, 0-n arguments

For methods: callback, object (method host), methodName, context, 0-n arguments

#### Returns:

detach handle

### `bubble`

(

- `evt`

)
Boolean

Inherited from EventTarget: `event-custom/js/event-facade.js:424`

Propagate an event. Requires the event-custom-complex module.

#### Parameters:

- `evt` CustomEvent

  the custom event to propagate

#### Returns:

Boolean: the aggregated return value from Event.Custom.fire

### `destroy`

() Base chainable

Inherited from BaseCore but overwritten in `base/js/Base.js:267`

Destroy lifecycle method. Fires the destroy event, prior to invoking destructors for the class hierarchy.

Subscribers to the destroy event can invoke preventDefault on the event object, to prevent destruction from proceeding.

#### Returns:

Base: A reference to this object

### `detach`

(

- `type`
- `fn`
- `context`

)
EventTarget

Inherited from EventTarget: `event-custom/js/event-target.js:344`

Detach one or more listeners the from the specified event

#### Parameters:

- `type` String | Object

  Either the handle to the subscriber or the type of event. If the type is not specified, it will attempt to remove the listener from all hosted events.

- `fn` Function

  The subscribed function to unsubscribe, if not supplied, all subscribers will be removed.

- `context` Object

  The custom object passed to subscribe. This is optional, but if supplied will be used to disambiguate multiple listeners that are the same (e.g., you subscribe many object using a function that lives on the prototype)

#### Returns:

EventTarget: the host

### `detachAll`

(

- `type`

)

Inherited from EventTarget: `event-custom/js/event-target.js:464`

Removes all listeners from the specified event. If the event type is not specified, all listeners from all hosted custom events will be removed.

#### Parameters:

- `type` String

  The type, or name of the event

### `extract`

(

- `filemap`
- `dirmap`

)
Object

Defined in `lib/docparser.js:1157`

Accepts a map of filenames to file content. Returns a map of filenames to an array of API comment block text. This expects the comment to start with / ** on its own line, and end with * / on its own line. Override this function to provide an alternative comment parser.

#### Parameters:

- `filemap` Object

  A map of filenames to file content

- `dirmap` Array

  A map of file names to directory name

#### Returns:

Object: A map of filenames to an array of extracted comment text.

### `fire`

(

- `type`
- `arguments`

)
EventTarget

Inherited from EventTarget: `event-custom/js/event-target.js:641`

Fire a custom event by name. The callback functions will be executed from the context specified when the event was created, and with the following parameters.

If the custom event object hasn't been created, then the event hasn't been published and it has no subscribers. For performance sake, we immediate exit in this case. This means the event won't bubble, so if the intention is that a bubble target be notified, the event must be published on this object first.

The first argument is the event type, and any additional arguments are passed to the listeners as parameters. If the first of these is an object literal, and the event is configured to emit an event facade, that object is mixed into the event facade and the facade is provided in place of the original object.

#### Parameters:

- `type` String | Object

  The type of the event, or an object that contains a 'type' property.

- `arguments` Object*

  an arbitrary set of parameters to pass to the handler. If the first of these is an object literal and the event is configured to emit an event facade, the event facade will replace that parameter after the properties the object literal contains are copied to the event facade.

#### Returns:

EventTarget: the event host

### `get`

(

- `name`

)
Any

Inherited from AttributeCore: `attribute/js/AttributeCore.js:283`

Returns the current value of the attribute. If the attribute has been configured with a 'getter' function, this method will delegate to the 'getter' to obtain the value of the attribute.

#### Parameters:

- `name` String

  The name of the attribute. If the value of the attribute is an Object, dot notation can be used to obtain the value of a property of the object (e.g. `get("x.y.z")`)

#### Returns:

Any: The value of the attribute

### `getAttrs`

(

- `attrs`

)
Object

Inherited from AttributeCore: `attribute/js/AttributeCore.js:666`

Gets multiple attribute values.

#### Parameters:

- `attrs` Array | boolean

  Optional. An array of attribute names. If omitted, all attribute values are returned. If set to true, all attributes modified from their initial values are returned.

#### Returns:

Object: An object with attribute name/value pairs.

### `getEvent`

(

- `type`
- `prefixed`

)
CustomEvent

Inherited from EventTarget: `event-custom/js/event-target.js:726`

Returns the custom event of the provided type has been created, a falsy value otherwise

#### Parameters:

- `type` String

  the type, or name of the event

- `prefixed` String

  if true, the type is prefixed already

#### Returns:

CustomEvent: the custom event or null

### `getTargets`

()

Inherited from EventTarget: `event-custom/js/event-facade.js:405`

Returns an array of bubble targets for this object.

#### Returns:

EventTarget[]

### `handlecomment`

(

- `comment`
- `file`
- `line`

)

Defined in `lib/docparser.js:1086`

Transforms a JavaDoc style comment block (less the start and end of it) into a list of tag/text pairs. The leading space and '*' are removed, but the remaining whitespace is preserved so that the output should be friendly for both markdown and html parsers.

#### Parameters:

- `comment` String

  The comment to parse

- `file` String

  The file it was parsed from

- `line` String

  The line number it was found on

### `init`

(

- `config`

)
Base chainable

Inherited from BaseCore but overwritten in `base/js/Base.js:191`

Init lifecycle method, invoked during construction. Fires the init event prior to setting up attributes and invoking initializers for the class hierarchy.

#### Parameters:

- `config` Object

  Object with configuration property name/value pairs

#### Returns:

Base: A reference to this object

### `modifyAttr`

(

- `name`
- `config`

)

Inherited from AttributeExtras: `attribute/js/AttributeExtras.js:39`

Updates the configuration of an attribute which has already been added.

The properties which can be modified through this interface are limited to the following subset of attributes, which can be safely modified after a value has already been set on the attribute: readOnly, writeOnce, broadcast and getter.

#### Parameters:

- `name` String

  The name of the attribute whose configuration is to be updated.

- `config` Object

  An object with configuration property/value pairs, specifying the configuration properties to modify.

### `on`

(

- `type`
- `fn`
- `[context]`
- `[arg*]`

)
EventHandle

Inherited from EventTarget: `event-custom/js/event-target.js:191`

Subscribe a callback function to a custom event fired by this object or from an object that bubbles its events to this object.

Callback functions for events published with `emitFacade = true` will receive an `EventFacade` as the first argument (typically named "e"). These callbacks can then call `e.preventDefault()` to disable the behavior published to that event's `defaultFn`. See the `EventFacade` API for all available properties and methods. Subscribers to non-`emitFacade` events will receive the arguments passed to `fire()` after the event name.

To subscribe to multiple events at once, pass an object as the first argument, where the key:value pairs correspond to the eventName:callback, or pass an array of event names as the first argument to subscribe to all listed events with the same callback.

Returning `false` from a callback is supported as an alternative to calling `e.preventDefault(); e.stopPropagation();`. However, it is recommended to use the event methods whenever possible.

#### Parameters:

- `type` String

  The name of the event

- `fn` Function

  The callback to execute in response to the event

- `[context]` Object optional

  Override `this` object in callback

- `[arg*]` Any optional

  0..n additional arguments to supply to the subscriber

#### Returns:

EventHandle: A subscription handle capable of detaching that subscription

### `once`

(

- `type`
- `fn`
- `[context]`
- `[arg*]`

)
EventHandle

Inherited from EventTarget: `event-custom/js/event-target.js:127`

Listen to a custom event hosted by this object one time. This is the equivalent to `on` except the listener is immediatelly detached when it is executed.

#### Parameters:

- `type` String

  The name of the event

- `fn` Function

  The callback to execute in response to the event

- `[context]` Object optional

  Override `this` object in callback

- `[arg*]` Any optional

  0..n additional arguments to supply to the subscriber

#### Returns:

EventHandle: A subscription handle capable of detaching the subscription

### `onceAfter`

(

- `type`
- `fn`
- `[context]`
- `[arg*]`

)
EventHandle

Inherited from EventTarget: `event-custom/js/event-target.js:149`

Listen to a custom event hosted by this object one time. This is the equivalent to `after` except the listener is immediatelly detached when it is executed.

#### Parameters:

- `type` String

  The name of the event

- `fn` Function

  The callback to execute in response to the event

- `[context]` Object optional

  Override `this` object in callback

- `[arg*]` Any optional

  0..n additional arguments to supply to the subscriber

#### Returns:

EventHandle: A subscription handle capable of detaching that subscription

### `parse`

(

- `filemap`
- `dirmap`

)
DocParser

Defined in `lib/docparser.js:1398`

Extracts and transforms the filemap provided to constructor

#### Parameters:

- `filemap` Array

  A map of filenames to file content

- `dirmap` Array

  A map of file names to directory name

#### Returns:

DocParser: this parser instance. The total results are available in parser.data.

### `parseType`

(

- `type`
- `[pre=this._yuievt.config.prefix]`

)
Array

Inherited from EventTarget: `event-custom/js/event-target.js:171`

Available since 3.3.0

Takes the type parameter passed to 'on' and parses out the various pieces that could be included in the type. If the event type is passed without a prefix, it will be expanded to include the prefix one is supplied or the event target is configured with a default prefix.

#### Parameters:

- `type` String

  the type

- `[pre=this._yuievt.config.prefix]` String optional

  the prefix

#### Returns:

Array: an array containing: * the detach category, if supplied, * the prefixed event type, * whether or not this is an after listener, * the supplied event type

### `processblock`

(

- `an`

)

Defined in `lib/docparser.js:1211`

Processes all the tags in a single comment block

#### Parameters:

- `an` Array

  array of the tag/text pairs

### `publish`

(

- `type`
- `opts`

)
CustomEvent

Inherited from EventTarget: `event-custom/js/event-target.js:488`

Creates a new custom event of the specified type. If a custom event by that name already exists, it will not be re-created. In either case the custom event is returned.

#### Parameters:

- `type` String

  the type, or name of the event

- `opts` Object

  optional config params. Valid properties are:

  - 'broadcast': whether or not the YUI instance and YUI global are notified when the event is fired (false)
  - 'bubbles': whether or not this event bubbles (true) Events can only bubble if emitFacade is true.
  - 'context': the default execution context for the listeners (this)
  - 'defaultFn': the default function to execute when this event fires if preventDefault was not called
  - 'emitFacade': whether or not this event emits a facade (false)
  - 'prefix': the prefix for this targets events, e.g., 'menu' in 'menu:click'
  - 'fireOnce': if an event is configured to fire once, new subscribers after the fire will be notified immediately.
  - 'async': fireOnce event listeners will fire synchronously if the event has already fired unless async is true.
  - 'preventable': whether or not preventDefault() has an effect (true)
  - 'preventedFn': a function that is executed when preventDefault is called
  - 'queuable': whether or not this event can be queued during bubbling (false)
  - 'silent': if silent is true, debug messages are not provided for this event.
  - 'stoppedFn': a function that is executed when stopPropagation is called

  - 'monitored': specifies whether or not this event should send notifications about when the event has been attached, detached, or published.
  - 'type': the event type (valid option if not provided as the first parameter to publish)

#### Returns:

CustomEvent: the custom event

### `removeAttr`

(

- `name`

)

Inherited from AttributeExtras: `attribute/js/AttributeExtras.js:77`

Removes an attribute from the host object

#### Parameters:

- `name` String

  The name of the attribute to be removed.

### `removeTarget`

(

- `o`

)

Inherited from EventTarget: `event-custom/js/event-facade.js:414`

Removes a bubble target

#### Parameters:

- `o` EventTarget

  the target to remove

### `reset`

(

- `name`

)
Object chainable

Inherited from AttributeExtras: `attribute/js/AttributeExtras.js:87`

Resets the attribute (or all attributes) to its initial value, as long as the attribute is not readOnly, or writeOnce.

#### Parameters:

- `name` String

  Optional. The name of the attribute to reset. If omitted, all attributes are reset.

#### Returns:

Object: A reference to the host object.

### `set`

(

- `name`
- `value`

)
Object chainable

Inherited from AttributeEvents but overwritten in `attribute/js/AttributeCore.js:328`

Sets the value of an attribute.

#### Parameters:

- `name` String

  The name of the attribute. If the current value of the attribute is an Object, dot notation can be used to set the value of a property within the object (e.g. `set("x.y.z", 5)`).

- `value` Any

  The value to set the attribute to.

#### Returns:

Object: A reference to the host object.

### `setAttrs`

(

- `attrs`

)
Object chainable

Inherited from AttributeEvents but overwritten in `attribute/js/AttributeCore.js:635`

Sets multiple attribute values.

#### Parameters:

- `attrs` Object

  An object with attributes name/value pairs.

#### Returns:

Object: A reference to the host object.

### `stringlog`

(

- `data`

)
String private

Defined in `lib/docparser.js:12`

Parses the JSON data and formats it into a nice log string for filename and line number: `/file/name.js:123`

#### Parameters:

- `data` Object

  The data block from the parser

#### Returns:

String: The formatted string.

### `subscribe`

() deprecated

Inherited from EventTarget: `event-custom/js/event-target.js:334`

Deprecated: use on

subscribe to an event

### `toString`

() String

Inherited from BaseCore: `base/js/BaseCore.js:596`

Default toString implementation. Provides the constructor NAME and the instance guid, if set.

#### Returns:

String: String representation for this object

### `transform`

(

- `commentmap`

)
Object

Defined in `lib/docparser.js:1285`

Transforms a map of filenames to arrays of comment blocks into a JSON structure that represents the entire processed API doc info and relationships between elements for the entire project.

#### Parameters:

- `commentmap` Object

  The hash of files and parsed comment blocks

#### Returns:

Object: The transformed data for the project

### `unindent`

(

- `content`

)
String private

Defined in `lib/docparser.js:1064`

Normalizes the initial indentation of the given content so that the first line is unindented, and all other lines are unindented to the same degree as the first line. So if the first line has four spaces at the beginning, then all lines will be unindented four spaces. Ported from Selleck

#### Parameters:

- `content` String

  Text to unindent.

#### Returns:

String: Unindented text.

### `unsubscribe`

() deprecated

Inherited from EventTarget: `event-custom/js/event-target.js:454`

Deprecated: use detach

detach a listener

### `unsubscribeAll`

(

- `type`

)
deprecated

Inherited from EventTarget: `event-custom/js/event-target.js:475`

Deprecated: use detachAll

Removes all listeners from the specified event. If the event type is not specified, all listeners from all hosted custom events will be removed.

#### Parameters:

- `type` String

  The type, or name of the event

## Properties

### `_allowAdHocAttrs`

Boolean protected

Inherited from BaseCore: `base/js/BaseCore.js:101`

This property controls whether or not instances of this class should allow users to add ad-hoc attributes through the constructor configuration hash.

AdHoc attributes are attributes which are not defined by the class, and are not handled by the MyClass.NONATTRS_CFG

Default: undefined (false)

### `CORRECTIONS`

Object final

Defined in `lib/docparser.js:175`

Common errors will get scrubbed instead of being ignored.

### `DIGESTERS`

Object final

Defined in `lib/docparser.js:198`

A map of the default tag processors, keyed by the tag name. Multiple tags can use the same digester by supplying the string name that points to the implementation rather than a function.

### `name`

String deprecated

Inherited from BaseCore: `base/js/BaseCore.js:197`

Deprecated: Use this.constructor.NAME

The string used to identify the class of this object.

### `TAGLIST`

Array final

Defined in `lib/docparser.js:95`

A list of known tags. This populates a member variable during initialization, and will be updated if additional digesters are added.

## Attributes

### `currentclass`

String

Defined in `lib/docparser.js:955`

The class currently being parsed

#### Fires event `currentclassChange`

Fires when the value for the configuration attribute `currentclass` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `currentfile`

String

Defined in `lib/docparser.js:806`

The file currently being parsed

#### Fires event `currentfileChange`

Fires when the value for the configuration attribute `currentfile` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `currentmodule`

String

Defined in `lib/docparser.js:863`

The module currently being parsed

#### Fires event `currentmoduleChange`

Fires when the value for the configuration attribute `currentmodule` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `currentsubmodule`

String

Defined in `lib/docparser.js:915`

The submodule currently being parsed

#### Fires event `currentsubmoduleChange`

Fires when the value for the configuration attribute `currentsubmodule` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `destroyed`

Boolean readonly

Inherited from BaseCore: `base/js/BaseCore.js:158`

Flag indicating whether or not this object has been through the destroy lifecycle phase.

Default: false

#### Fires event `destroyedChange`

Fires when the value for the configuration attribute `destroyed` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `digesters`

Defined in `lib/docparser.js:746`

Digesters process the tag/text pairs found in a comment block. They are looked up by tag name. The digester gets the tagname, the value, the target object to apply values to, and the full block that is being processed. Digesters can be declared as strings instead of a function -- in that case, the program will try to look up the key listed and use the function there instead (it is an alias). Digesters can return a host object in the case the tag defines a new key block type (modules/classes/methods/events/properties)

#### Fires event `digestersChange`

Fires when the value for the configuration attribute `digesters` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `dirmap`

Defined in `lib/docparser.js:796`

A map of file names to directory name. Provided in case this needs to be used to reset the module name appropriately -- currently not used

#### Fires event `dirmapChange`

Fires when the value for the configuration attribute `dirmap` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `emitters`

Defined in `lib/docparser.js:768`

Emitters will be schemas for the types of payloads the parser will emit. Not implemented.

#### Fires event `emittersChange`

Fires when the value for the configuration attribute `emitters` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `filemap`

Defined in `lib/docparser.js:788`

The map of file names to file content.

#### Fires event `filemapChange`

Fires when the value for the configuration attribute `filemap` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `initialized`

Boolean readonly

Inherited from BaseCore: `base/js/BaseCore.js:144`

Flag indicating whether or not this object has been through the init lifecycle phase.

Default: false

#### Fires event `initializedChange`

Fires when the value for the configuration attribute `initialized` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `mainmodule`

String

Defined in `lib/docparser.js:827`

The main documentation block for the module itself.

#### Fires event `mainmoduleChange`

Fires when the value for the configuration attribute `mainmodule` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

### `syntaxtype`

String

Defined in `lib/docparser.js:779`

Comment syntax type.

#### Fires event `syntaxtypeChange`

Fires when the value for the configuration attribute `syntaxtype` is changed. You can listen for the event using the `on` method if you wish to be notified before the attribute's value has changed, or using the `after` method if you wish to be notified after the attribute's value has changed.

#### Parameters:

- `e` EventFacade
  An Event Facade object with the following attribute-specific properties added:
  - `prevVal` Any
    The value of the attribute, prior to it being set.
  - `newVal` Any
    The value the attribute is to be set to.
  - `attrName` String
    The name of the attribute being set.
  - `subAttrName` String
    If setting a property within the attribute's value, the name of the sub-attribute property being set.

## Events

### `destroy`

Inherited from Base: `base/js/Base.js:285`

Lifecycle event for the destroy phase, fired prior to destruction. Invoking the preventDefault method on the event object provided to subscribers will prevent destruction from proceeding.

Subscribers to the "after" moment of this event, will be notified after destruction is complete (and as a result cannot prevent destruction).

#### Event Payload:

- `e` EventFacade

  Event object

### `init`

Inherited from Base: `base/js/Base.js:202`

Lifecycle event for the init phase, fired prior to initialization. Invoking the preventDefault() method on the event object provided to subscribers will prevent initialization from occuring.

Subscribers to the "after" momemt of this event, will be notified after initialization of the object is complete (and therefore cannot prevent initialization).

#### Event Payload:

- `e` EventFacade

  Event object, with a cfg property which refers to the configuration object passed to the constructor.